pipeline {
  agent any

  stages {
     stage('Build') {
      steps {
         Checkout source code from version control
        checkout scm
      //   Build your project (e.g., Maven, Gradle)
        sh 'mvn clean package'
      }
    }

    stage('Test') {
      steps {
        // Run your tests (e.g., JUnit, Selenium)
        sh 'mvn test'
      }
    }
    stage('gitlab') {
          steps {
             echo 'Notify GitLab'
             updateGitlabCommitStatus name: 'build', state: 'pending'
             updateGitlabCommitStatus name: 'build', state: 'success'
          }
       }
    stage('Deploy to Tomcat') {
      steps {
        // Deploy your application (e.g., Docker, Kubernetes)
        sh sshagent(credentials: ['	d955fe7e-b2f3-45ff-9153-5b6ffba71351']) {
                    sh 'ssh root@tomcat-server "sudo systemctl stop tomcat"'
                    sh 'ssh root@tomcat-server "rm -rf /opt/tomcat/webapps"'
                    sh 'scp /var/lib/jenkins/workspace/demo/target/webapp/webapp.war root@tomcat-server:/opt/tomcat/webapps'
                    sh 'ssh root@tomcat-server "sudo systemctl start tomcat"'
      //            ssh -o StrictHostKeyChecking=no host
      }
    }

    stage('Verify') {
      steps {
         Perform additional verification or integration tests
        sh 'curl http://15.206.68.64:8080/'
      }
    }
    stage('Rollback') {
            when {
                Run the rollback stage only if the previous build has failed
                expression { currentBuild.result != 'SUCCESS' }
            }
         } 
    stage('Deploy to Production') {
       Run this stage only if the previous stages were successful
      when {
            expression { currentBuild.result == 'SUCCESS'}
//      }
//    }
  //    steps {
  //      Deploy your application to production environment
        //sh 'kubectl apply -f production-deployment.yaml'
   //   }
  // post {
  //  always {
  //     Archive your build artifacts
  //    archiveArtifacts artifacts: 'target/*.jar', fingerprint: true
  //  }
// }
    success {
       Send email notification on successful build
      emailext body: 'The build was successful!', recipientProviders: [[$class: 'DevelopersRecipientProvider']]
    }

  // failure {
  //     Send email notification on failed build
  //   emailext body: 'The build failed!', recipientProviders: [[$class: 'DevelopersRecipientProvider']]
  //  }
    }
  }
}
